# -*- coding: utf-8 -*-
from enigma import ePicLoad
from enigma import eTimer
from enigma import getDesktop
from Screens.Screen import Screen
from Components.Pixmap import Pixmap
from Components.Pixmap import MovingPixmap
from Components.ActionMap import ActionMap
from Components.ActionMap import NumberActionMap
from Components.Sources.StaticText import StaticText
from Components.AVSwitch import AVSwitch
from Components.config import config
from Components.config import ConfigSubsection
from Components.config import ConfigInteger
from Components.config import ConfigSelection
from Components.config import ConfigEnableDisable
from os import path
from os import listdir
import os
from Components.MenuList import MenuList
from Components.Button import Button
from Components.Label import Label
# added by Murxer(01102021) -->
try:
    import urllib.request as urllib # py 3
except ImportError as error:
    print(error)
    import urllib # py 2
import platform
# added by Murxer(01102021) <--

from .Helpinfo import bpinfoscreen
from .language import _
plugin_path = '/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/'


def getScale():
    return AVSwitch().getFramebufferScale()

T_INDEX = 0
T_FRAME_POS = 1
T_PAGE = 2
T_NAME = 3
T_FULL = 4
config.bpirat = ConfigSubsection()
config.bpirat.framesize = ConfigInteger(default = 30, limits = (5, 99))
config.bpirat.slidetime = ConfigInteger(default = 10, limits = (1, 60))
config.bpirat.resize = ConfigSelection(choices = [('0', _('simple')), ('1', _('better'))], default = '1')
config.bpirat.cache = ConfigEnableDisable(default = True)
config.bpirat.bgcolor = ConfigSelection(choices = [('#00000000', _('black')), ('#009eb9ff', _('blue')), ('#00ff5a51', _('red')), ('#00ffe875', _('yellow')), ('#0038FF48', _('green'))], default = '#00000000')
config.bpirat.textcolor = ConfigSelection(choices = [('#6495ED', _('CornflowerBlue')), ('#009eb9ff', _('blue')), ('#00ff5a51', _('red')), ('#00ffe875', _('yellow')), ('#0038FF48', _('green'))], default = '#00ff5a51')


# modified by Lizard(17092022) -->
def checkurl():
    hosts = ["bpfeed.boxpirates.to"]
    for host in hosts:
        try:
            status_code = urllib.urlopen("http://" + host + "/index.html").getcode()
            if status_code == 200:
                return host
            else:
                continue
        except Exception as error:
            print("Error: ", error)
    return None
# modifed by Lizard(17092022) <--


# added by Murxer(01102021) -->
arch_list = {"aarch64": ["-arm64", "-aarch64"],
             "arm64": ["-arm64", "-aarch64"],
             "armv7l": ["-armf", "-armv7", "-arm+dream"],
             "armhf": ["-armf", "-armv7", "-arm+dream"],
             "mips": ["-mips", "-mipsel", "mipsoe20"],
             "mipsel": ["-mips", "-mipsel", "mipsoe20"],
             "default": []}


def getProcessorArchitecturePlatform():
    architecture = "default"
    try:
        architecture = platform.machine()
    except Exception as error:
        print(error)
    print(architecture)
    return arch_list[architecture] if arch_list.get(architecture) else []


def getArchSortList(data):
    package = []
    arch_package = []
    arch = getProcessorArchitecturePlatform()
    for line in data:
        package.append(line)
        if arch:
            for a in arch:
                if a in line:
                    arch_package.append(line)
                    break
    sort = True if arch_package else False
    return arch_package if arch_package else package, sort
# added by Murxer(01102021) <--


class BoxPiratescamdownload(Screen):
    def __init__(self, session):
        self.folder = '/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/'
        self.fillplgfolders()
        piclist = self.fullpath
        path = self.folder
        lastindex = 0
        self.color = config.bpirat.bgcolor.value
        self.mtitle = _('BP-Feed-Softcam-Config-Download')
        dwidth = getDesktop(0).size().width()
        size_w = getDesktop(0).size().width()
        size_h = getDesktop(0).size().height()
        if dwidth == 1280:
            size_w = 700
            size_h = 500
            textsize = 25
            self.spaceX = 55
            self.picX = 166
            self.spaceY = 9
            self.picY = 155
        else:
            size_w = 1000
            size_h = 700
            textsize = 30
            self.spaceX = 130
            self.picX = 165
            self.spaceY = 50
            self.picY = 165
        self.thumbsX = 3
        self.thumbsY = 3
        self.thumbsC = self.thumbsX * self.thumbsY
        self.positionlist = []
        skincontent = ''
        posX = -1
        if dwidth == 1280:
            for x in range(self.thumbsC):
                posY = int(x / self.thumbsX)
                posX += 1
                if posX >= self.thumbsX:
                    posX = 0
                absX = self.spaceX + posX * (self.spaceX + self.picX)
                absY = self.spaceY + posY * (self.spaceY + self.picY)
                self.positionlist.append((absX, absY))
                skincontent += '<widget source="label' + str(x) + '" render="Label" position="' + str(absX - 5) + ',' + str(absY + self.picY - textsize + 9) + '" size="' + str(self.picX - 10) + ',' + str(textsize) + '" font="Regular;18" zPosition="2" transparent="1" noWrap="1" halign="' + 'center' + '"  valign="' + 'center' + '" />'
                skincontent += '<widget name="thumb' + str(x) + '" position="' + str(absX + 5) + ',' + str(absY + 0) + '" size="' + str(self.picX - 30) + ',' + str(self.picY - 20) + '" zPosition="2" transparent="1" alphatest="blend" />'

            self.skin = '<screen position="center,center"  title="' + self.mtitle + '"  size="' + str(size_w) + ',' + str(size_h) + '" > \t\t\t<eLabel position="0,0" zPosition="0" size="' + str(size_w) + ',' + str(size_h) + '" /><widget name="frame" position="20,20" size="148,148" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/gobutton.png" zPosition="1" alphatest="blend" />' + skincontent + '</screen>'
 
        else:
            for x in range(self.thumbsC):
                posY = int(x / self.thumbsX)
                posX += 1
                if posX >= self.thumbsX:
                    posX = 0
                absX = self.spaceX + posX * (self.spaceX + self.picX)
                absY = self.spaceY + posY * (self.spaceY + self.picY)
                self.positionlist.append((absX, absY))
                skincontent += '<widget source="label' + str(x) + '" render="Label" position="' + str(absX - 5) + ',' + str(absY + self.picY - 10) + '" size="' + str(self.picX - 10) + ',' + str(textsize) + '" font="Regular;24" zPosition="2" transparent="1" noWrap="1" halign="' + 'center' + '"  valign="' + 'center' + '" />'
                skincontent += '<widget name="thumb' + str(x) + '" position="' + str(absX + 5) + ',' + str(absY + 0) + '" size="' + str(self.picX - 30) + ',' + str(self.picY - 20) + '" zPosition="2" transparent="1" alphatest="blend" />'

        self.skin = '<screen position="center,center"   title="' + _("BP-Feed-Softcam-Config-Download") + '"  size="' + str(size_w) + ',' + str(size_h) + '" > \t\t\t<eLabel position="0,0" zPosition="0" size="' + str(size_w) + ',' + str(size_h) + '" /><widget name="frame" position="0,0" size="155,155" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/gobutton.png" zPosition="1" alphatest="blend" />' + skincontent + '</screen>'
        Screen.__init__(self, session)
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions', 'DirectionActions', 'MovieSelectionActions'], {'right': self.key_right, 'ok': self.KeyOk, 'up': self.key_up, 'down': self.key_down, 'cancel': self.Exit, 'left': self.key_left}, -1)
        self['frame'] = MovingPixmap()
        for x in range(self.thumbsC):
            self['label' + str(x)] = StaticText()
            self['thumb' + str(x)] = Pixmap()
        self.Thumbnaillist = []
        self.filelist = []
        self.currPage = -1
        self.dirlistcount = 0
        self.path = path
        index = 0
        framePos = 0
        Page = 0
        for x in piclist:
            if x:
                self.filelist.append((index, framePos, Page, x, path + x))
                index = index + 1
                framePos = framePos + 1
                if framePos > self.thumbsC - 1:
                    framePos = 0
                    Page = Page + 1
            else:
                self.dirlistcount = self.dirlistcount + 1
        self.maxentry = len(self.filelist) - 1
        self.index = lastindex - self.dirlistcount
        if self.index < 0:
            self.index = 0
        self.picload = ePicLoad()
        self.onLayoutFinish.append(self.setPicloadConf)

    def fillplgfolders(self):
        plgfolders = []
        fullpath = []
        for x in listdir(self.folder):
            if path.isfile(self.folder + x):
                if x.endswith('.png'):
                    plgfolders.append(x)
                    fullpath.append(x)
                continue
        self.fullpath = fullpath

    def setPicloadConf(self):
        sc = getScale()
        self.picload.setPara([self['thumb0'].instance.size().width(), self['thumb0'].instance.size().height(), sc[0], sc[1], config.bpirat.cache.value, int(config.bpirat.resize.value), self.color])
        self.initFrame()
        self.paintFrame()

    def initFrame(self):
        self.positionlist = []
        for x in range(self.thumbsC):
            frame_pos = self['thumb' + str(x)].getPosition()
            self.positionlist.append((frame_pos[0] - 6, frame_pos[1] - 4))
        frame_pos = self['thumb0'].getPosition()
        self['frame'].setPosition(frame_pos[0] - 5, frame_pos[1] - 5)

    def paintFrame(self):
        if self.maxentry < self.index or self.index < 0:
            return
        else:
            pos = self.positionlist[self.filelist[self.index][T_FRAME_POS]]
            self['frame'].moveTo(pos[0], pos[1], 1)
            self['frame'].startMoving()
            if self.currPage != self.filelist[self.index][T_PAGE]:
                self.currPage = self.filelist[self.index][T_PAGE]
                self.newPage()
            return

    def newPage(self):
        self.Thumbnaillist = []
        for x in range(self.thumbsC):
            self['label' + str(x)].setText('')
            self['thumb' + str(x)].hide()
        for x in self.filelist:
            if x[T_PAGE] == self.currPage:
                self['label' + str(x[T_FRAME_POS])].setText('(' + str(x[T_INDEX] + 1) + ') ' + x[T_NAME])
                self.Thumbnaillist.append([0, x[T_FRAME_POS], x[T_FULL]])
                continue
        self['label0'].setText(_('OScam'))
        self['label1'].setText(_('Configs'))
        self['label2'].setText(_('Gbox'))
        self['label3'].setText(_('CCcam'))
        self['label4'].setText(_('MGcamd'))
        self['label5'].setText(_('Camd3'))
        self['label6'].setText(_('Scam'))
        self['label7'].setText(_('Picon'))
        self['label8'].setText(_('Back'))
        self.showPic()

    def showPic(self, picInfo = ''):
        self['thumb' + str(self.Thumbnaillist[0][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/OScam.png')
        self['thumb' + str(self.Thumbnaillist[0][1])].show()
        self['thumb' + str(self.Thumbnaillist[1][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/Config.png')
        self['thumb' + str(self.Thumbnaillist[1][1])].show()
        self['thumb' + str(self.Thumbnaillist[2][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/Gbox.png')
        self['thumb' + str(self.Thumbnaillist[2][1])].show()
        self['thumb' + str(self.Thumbnaillist[3][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/CCcam.png')
        self['thumb' + str(self.Thumbnaillist[3][1])].show()
        self['thumb' + str(self.Thumbnaillist[4][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/Mgcamd.png')
        self['thumb' + str(self.Thumbnaillist[4][1])].show()
        self['thumb' + str(self.Thumbnaillist[5][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/Camd3.png')
        self['thumb' + str(self.Thumbnaillist[5][1])].show()
        self['thumb' + str(self.Thumbnaillist[6][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/scam.png')
        self['thumb' + str(self.Thumbnaillist[6][1])].show()
        self['thumb' + str(self.Thumbnaillist[7][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/picon.png')
        self['thumb' + str(self.Thumbnaillist[7][1])].show()
        self['thumb' + str(self.Thumbnaillist[8][1])].instance.setPixmapFromFile('/usr/lib/enigma2/python/Plugins/Extensions/BoxPirates_CamManager/png/menue/zurueck.png')
        self['thumb' + str(self.Thumbnaillist[8][1])].show()

    def key_left(self):
        self.index = self.index - 1
        if self.index < 0:
            self.index = self.maxentry
        self.paintFrame()

    def key_right(self):
        self.index = self.index + 1
        if self.index > self.maxentry:
            self.index = 0
        self.paintFrame()

    def key_up(self):
        self.index = self.index - self.thumbsX
        if self.index < 0:
            self.index = self.maxentry
        self.paintFrame()

    def key_down(self):
        self.index = self.index + self.thumbsX
        if self.index > self.maxentry:
            self.index = 0
        self.paintFrame()

    def KeyOk(self):
        if self.maxentry < 0:
            return
        else:
            if self.index == 0:
                self.session.open(GetCamlist, "oscam")
            if self.index == 1:
                self.session.open(GetCamlist, "config")
            if self.index == 2:
                self.session.open(GetCamlist, "gbox")
            if self.index == 3:
                self.session.open(GetCamlist, "cccam")
            if self.index == 4:
                self.session.open(GetCamlist, "mgcamd")
            if self.index == 5:
                self.session.open(GetCamlist, "camd3")
            if self.index == 6:
                self.session.open(GetCamlist, "scam")
            if self.index == 7:
                self.session.open(GetCamlist, "picon")
            elif self.index == 8:
                self.close()
            return

    def callbackView(self, val = 0):
        self.index = val
        if self.old_index != self.index:
            self.paintFrame()

    def Exit(self):
        del self.picload
        self.close(self.index + self.dirlistcount)

    def restartenigma(self):
        os.system('killall -9 enigma2')


screensize = getDesktop(0).size().height()


class GetCamlist(Screen):
    if screensize == 720:
        skin = '''<screen title="''' + _("Download") + '''" position="center,center" size="700,500"> 
                        <widget name="info" position="30,250" zPosition="4" size="640,90" font="Regular;20" foregroundColor="yellow" transparent="1" halign="center" valign="center" />  
                        <widget name="list" position="30,60" size="640,400" scrollbarMode="showOnDemand" itemHeight="25" />  
                        <widget name="key_red" position="0,10" size="175,24" font="Regular;18" halign="center" zPosition="2"  /> 
                        <eLabel name="button_red" position="0,0" size="175,8" backgroundColor="red" zPosition="1" />
                        <widget name="key_green" position="175,10" size="175,24" font="Regular;18" halign="center" zPosition="2"  />	
                        <eLabel name="button_green" position="175,0" size="175,8" backgroundColor="green" zPosition="1" />            
                        <widget name="key_yellow" position="350,10" size="175,24" font="Regular;18" halign="center" zPosition="2" /> 
                        <eLabel name="button_yellow" position="350,0" size="175,8" backgroundColor="yellow" zPosition="1" />
                        <eLabel name="blue" position="525,0" size="175,8" backgroundColor="blue" zPosition="1" /> 
                        <widget name="key_blue" position="525,10" size="175,24" font="Regular;18" halign="center" zPosition="2"  />	
                        </screen>'''
    if screensize == 1080:
        skin = '''<screen title="''' + _("Download") + '''" position="center,center" size="1000,700" > 
                <widget name="info" position="30,350" zPosition="4" size="940,90" font="Regular;28" foregroundColor="yellow" transparent="1" halign="center" valign="center" /> 
                <widget name="list" position="30,85" size="940,560" scrollbarMode="showOnDemand" itemHeight="35" />
                <widget name="key_red" position="0,15" size="250,28" font="Regular;25" halign="center" zPosition="2"  /> 
                <eLabel name="button_red" position="0,0" size="250,10" backgroundColor="red" zPosition="1" />
                <widget name="key_green" position="250,15" size="250,28" font="Regular;25" halign="center" zPosition="2"  />	
                <eLabel name="button_green" position="250,0" size="250,10" backgroundColor="green" zPosition="1" />            
                <widget name="key_yellow" position="500,15" size="250,28" font="Regular;25" halign="center" zPosition="2" />
                <eLabel name="button_yellow" position="500,0" size="250,10" backgroundColor="yellow" zPosition="1" />
                <eLabel name="blue" position="750,0" size="250,10" backgroundColor="blue" zPosition="1" />
                <widget name="key_blue" position="750,15" size="250,28" font="Regular;25" halign="center" zPosition="2"  />	 
                </screen>'''

    def __init__(self, session, mode):
        self.skin = GetCamlist.skin
        Screen.__init__(self, session)
        self['key_red'] = Button(_('Exit'))
        self['key_green'] = Button(_('Install'))
        self['key_yellow'] = Button('')
        self['key_blue'] = Button(_('Help/Info'))
        self.list = []
        self['list'] = MenuList([])
        self['info'] = Label()
        self['actions'] = NumberActionMap(['ColorActions', 'CiSelectionActions', 'WizardActions', 'SetupActions'], {"green": self.okClicked, "ok": self.okClicked, "red": self.close, "yellow": self.keyYellow, "cancel": self.close, "blue": self.Helpinfo}, -1)
        self.addon = 'emu'
        self.icount = 0
        self.sort = False
        self["info"].setText(_("Downloading list..."))

        if mode == "oscam":
            self.feed = "/camfeed/oe20/cam/oscam/listoscam"
        elif mode == "cccam":
            self.feed = "/camfeed/oe20/cam/cccam/listcccam"
        elif mode == "mgcamd":
            self.feed = "/camfeed/oe20/cam/mgcamd/listmgcamd"
        elif mode == "camd3":
            self.feed = "/camfeed/oe20/cam/camd3/listcamd3"
        elif mode == "scam":
            self.feed = "/camfeed/oe20/cam/scam/listscam"
        elif mode == "config":
            self.feed = "/camfeed/oe20/cam/config/listconfig"
        elif mode == "gbox":
            self.feed = "/camfeed/oe20/cam/gbox/listgbox"
        else:
            self.feed = "/camfeed/oe20/picons/piconlist"

        self.timer = eTimer()
        self.timer.callback.append(self.openTest)
        self.timer.start(100, 1)

    def openTest(self):
        bpurl = checkurl()
        if bpurl == None:
            self["info"].setText(_("BP feed not available..."))
            return
        xurl = 'http://' + bpurl + self.feed
        print('xurl =', xurl)
        xdest = '/tmp/ipklist.txt'
        print('xdest =', xdest)
        try:
            xlist = urllib.urlretrieve(xurl, xdest)
            myfile = open('/tmp/ipklist.txt', "r")
            self.data = []
            self.names = []
            icount = 0
            list = []
            data = getArchSortList(myfile.readlines())
            ipk_list = data[0]
            self.sort = data[1]
            for line in ipk_list:
                self.data.append(icount)
                self.names.append(icount)
                self.data[icount] = line[:-1]
                ipkname = self.data[icount]
                print('icount, ipk name =', icount, ipkname)
                ipos = ipkname.find('_')
                remname = ipkname[:ipos]
                self.names[icount] = remname
                icount = icount + 1
            if self.sort:
                self['key_yellow'].setText(_("Switch off") + " " + _("Filter"))
            self['info'].setText('')
            self['list'].setList(self.names)
        except:
            self['info'].setText(_("Internet connection error !"))

    def keyYellow(self):
        if self.sort:
            self.sort = False
            self['key_yellow'].setText("")
            try:
                myfile = open("/tmp/ipklist.txt", "r")
                self.data = []
                self.names = []
                icount = 0
                list = []

                for line in myfile.readlines():
                    self.data.append(icount)
                    self.names.append(icount)
                    self.data[icount] = line[:-1]
                    ipkname = self.data[icount]
                    print('icount, ipk name =', icount, ipkname)
                    ipos = ipkname.find('_')
                    remname = ipkname[:ipos]
                    self.names[icount] = remname
                    icount = icount + 1
                self["info"].setText("")
                self["list"].setList(self.names)
            except:
                self["info"].setText(_("Read list error!"))

    def okClicked(self):
        try:
            sel = self['list'].getSelectionIndex()
            addon = self.names[sel]
            ipk = self.data[sel]
            self.session.open(GetCamIpk, ipk, addon, self.feed)
        except:
            pass

    def keyLeft(self):
        self['text'].left()

    def keyRight(self):
        self['text'].right()

    def keyNumberGlobal(self, number):
        print('pressed', number)
        self['text'].number(number)

    def Helpinfo(self):
        self.session.open(bpinfoscreen)


class GetCamIpk(Screen):
    if screensize == 720:
        skin = '''<screen title="''' + _("Install ...") + '''" position="center,center" size="800,500"> 
                        <widget name="info" position="50,250" zPosition="4" size="800,45" font="Regular;20" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />  
                        <widget name="list" position="10,50" size="880,350" scrollbarMode="showOnDemand" itemHeight="25" />  
                        </screen>'''
    if screensize == 1080:
        skin = '''<screen title="''' + _("Install ...") + '''" position="center,center" size="1100,700" > 
                <widget name="info" position="50,350" zPosition="4" size="1000,45" font="Regular;28" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" /> 
                <widget name="list" position="10,100" size="1080,500" scrollbarMode="showOnDemand" itemHeight="35" />  
                </screen>'''

    def __init__(self, session, ipk, addon, feed):
        self.skin = GetCamIpk.skin
        Screen.__init__(self, session)
        self['list'] = MenuList([])
        self['info'] = Label()
        self['actions'] = ActionMap(['OkCancelActions'], {'cancel': self.close, 'ok': self.okClicked}, -1)
        self.icount = 0
        self.ipk = ipk
        self.addon = str(addon)
        self.feed = feed
        self["info"].setText(_("Downloading and installing..."))
        self.timer = eTimer()
        self.timer.callback.append(self.openTest)
        self.timer.start(100, 1)

    def openTest(self):
        bpurl = checkurl()
        if bpurl == None:
            self["info"].setText(_("BP feed not available..."))
            return
        xurl1 = 'http://' + bpurl + self.feed.replace(self.feed.split("/")[-1], "")
        print('xurl =', xurl1)
        xurl2 = xurl1 + self.ipk
        print('xurl2 =', xurl2)
        xdest2 = '/tmp/' + self.ipk
        print('xdest2 =', xdest2)
        try:
            self['info'].setText('')
            self.ipk = xurl1 + self.ipk
            cmd = 'opkg install --force-overwrite ' + self.ipk + '>/tmp/ipk.log'
            os.system(cmd)
            self.viewLog()
        except:
            self["info"].setText(_("Internet connection error !"))

    def keyLeft(self):
        self['text'].left()

    def keyRight(self):
        self['text'].right()

    def okClicked(self):
        self.close()

    def keyNumberGlobal(self, number):
        print('pressed', number)
        self['text'].number(number)

    def viewLog(self):
        print('In viewLog')
        self["info"].setText(_("Press OK to continue..."))
        if os.path.isfile('/tmp/ipk.log') is not True:
            cmd = 'touch /tmp/ipk.log'
            os.system(cmd)
        else:
            myfile = open('/tmp/ipk.log', "r")
            icount = 0
            data = []
            for line in myfile.readlines():
                if "Downloading" in line:
                    line = line.split(" ")[0] + " " + os.path.basename(line.split(" ")[1])
                data.append(icount)
                print(line)
                num = len(line)
                data[icount] = line[:-1]
                print(data[icount])
                icount = icount + 1
            self['list'].setList(data)
            self.endinstall()

    def endinstall(self):
        path = '/tmp'
        tmplist = []
        ipkname = 0
        tmplist = os.listdir(path)
        print('files in /tmp', tmplist)
        icount = 0
        for name in tmplist:
            nipk = tmplist[icount]
            if nipk[-3:] == 'ipk':
                ipkname = nipk
            icount = icount + 1
        if ipkname != 0:
            print('ipk name =', ipkname)
            ipos = ipkname.find('_')
            remname = ipkname[:ipos]
            print('remname =', remname)
            f = open('/etc/ipklist_installed', 'a')
            f1 = remname + '\n'
            f.write(f1)
            cmd = 'rm /tmp/*.ipk'
            os.system(cmd)
