from Screens.Screen import Screen
from Screens.Console import Console
from Components.ActionMap import ActionMap
from Components.MenuList import MenuList
from Components.Button import Button
from enigma import getDesktop
from Components.Label import Label
import os

from .language import _

screensize = getDesktop(0).size().height()


class BoxPiratescamuninstall(Screen):
    if screensize == 720:
        skin = '''<screen title="''' + _("Camuninstall") + '''" position="center,center" size="700,500" >
                         <widget name="info" position="50,465" zPosition="4" size="600,45" font="Regular;20" foregroundColor="yellow" transparent="1" halign="center"/> 		 
                             <widget name="menu" position="30,60" size="640,375" scrollbarMode="showOnDemand"  itemHeight="25"/> 
                         <widget name="key_red" position="0,10" size="175,24" font="Regular;18" halign="center" zPosition="2"  /> 
                         <eLabel name="button_red" position="0,0" size="175,8" backgroundColor="red" zPosition="1" />	
                                 <eLabel name="button_green" position="175,0" size="175,8" backgroundColor="green" zPosition="1" />            
                                 <eLabel name="button_yellow" position="350,0" size="175,8" backgroundColor="yellow" zPosition="1" />
                         <widget name="key_yellow" position="350,10" size="175,24" font="Regular;18" halign="center" zPosition="2"  />
                                 <eLabel name="blue" position="525,0" size="175,8" backgroundColor="blue" zPosition="1" />  
                         </screen>'''
    if screensize == 1080:
        skin = '''<screen title="''' + _("Camuninstall") + '''" position="center,center" size="1000,700" >  
                         <widget name="info" position="100,660" zPosition="4" size="800,45" font="Regular;28" foregroundColor="yellow" transparent="1" halign="center"/> 		
                 <widget name="menu" position="30,85" size="940,560" scrollbarMode="showOnDemand"  itemHeight="35"/> 
                 <widget name="key_red" position="0,15" size="250,28" font="Regular;25" halign="center" zPosition="2"  /> 
                 <eLabel name="button_red" position="0,0" size="250,10" backgroundColor="red" zPosition="1" />
                         <eLabel name="button_green" position="250,0" size="250,10" backgroundColor="green" zPosition="1" />            
                         <eLabel name="button_yellow" position="500,0" size="250,10" backgroundColor="yellow" zPosition="1" />
                 <widget name="key_yellow" position="500,15" size="250,28" font="Regular;25" halign="center" zPosition="2"  />	
                         <eLabel name="blue" position="750,0" size="250,10" backgroundColor="blue" zPosition="1" />  
                         </screen>'''

    def __init__(self, session):
        self.skin = BoxPiratescamuninstall.skin
        Screen.__init__(self, session)
        list = []
        self['menu'] = MenuList(list)
        self['key_red'] = Button(_('Exit'))
        self['key_yellow'] = Button(_('Uninstall'))
        self['ButtonBluetext'] = Label(_('Cam-uninstall'))
        self['info'] = Label()
        self['actions'] = ActionMap(['SetupActions', 'ColorActions'], {'yellow': self.prompt,
                                                                       'red': self.close,
                                                                       'cancel': self.close}, -2)
        self['info'].setText('usr/script/uninstall/')
        self.fillskins()

    def fillskins(self):
        list = []
        skins = []
        self['menu'].setList(skins)
        path = '/usr/script/uninstall/'
        self.path = path
        try:
            for x in os.listdir(path):
                x = x.replace('.sh', '')
                if not x == 'plu' or not x == 'script':
                    skins.append(x)
                    continue
            skins.sort()
            if len(skins) > 0:
                self['menu'].setList(skins)
                self['ButtonBluetext'].show()
            else:
                self['ButtonBluetext'].hide()
        except:
            pass

    def prompt(self):
        path = '/usr/script/uninstall/'
        try:
            selectedfolder = self['menu'].getCurrent()
            script = path + selectedfolder + '.sh'
            instr = 'Please wait while script is being  executed...'
            endstr = 'Press Ok to exit'
            dom = _('Executing: script')
            os.chmod(script, 755)

            self.session.openWithCallback(self.fillskins, Console, dom, [script])
            # self.session.openWithCallback(self.fillskins, BoxPiratesdelete, _('Executing: %s') % dom, [script], None, False, instr, endstr)
        except:
            pass

